Вопрос по java – Как скомпилировать mavenized OSGi 4.3 комплект с OpenJDK 7?

8

я пытаюсь скомпилировать свой OSGi-комплект в соответствии со спецификацией OSGi 4.3, используя OpenJDK7, но получаю ошибку:

[ERROR] Failed to execute goal org.apache.maven.plugins:maven-compiler-plugin:2.5:compile (default-compile) on project example: Compilation failure
[ERROR] /tmp/baka/example/src/main/java/org/example/Activator.java:[14,24] error: type ServiceReference does not take parameters

вот мой Activator.java:

package org.example;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

public class Activator implements BundleActivator {
    @Override
    public void start(BundleContext bundleContext) throws Exception {
        ServiceReference<Runnable> ref = bundleContext.getServiceReference(Runnable.class);
    }

    @Override
    public void stop(BundleContext bundleContext) throws Exception {
    }
}

и мой pom.xml:

<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>org.example</groupId>
    <artifactId>example</artifactId>
    <version>1.0-SNAPSHOT</version>
    <packaging>bundle</packaging>

    <name>example</name>
    <url>http://maven.apache.org</url>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    </properties>

    <dependencies>
        <dependency>
            <groupId>org.osgi</groupId>
            <artifactId>org.osgi.core</artifactId>
            <version>4.3.0</version>
        </dependency>
    </dependencies>


    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.felix</groupId>
                <artifactId>maven-bundle-plugin</artifactId>
                <version>2.3.7</version>
                <extensions>true</extensions>
                <configuration>
                    <instructions>
                        <Private-Package>org.example</Private-Package>
                        <Bundle-Activator>org.example.Activator</Bundle-Activator>
                    </instructions>
                </configuration>
            </plugin>
        </plugins>
    </build>

</project>

Эта ошибка не появляется, когда я использую OpenJDK 6. Любые советы, как заставить его работать с OpenJDK 7?

Ваш Ответ

1   ответ
11

7. OSGi скомпилировал код с использованием Java 6 javac с помощью -target jsr14. Java 7 javac убрал поддержку компиляции с такими файлами классов:http: //bugs.sun.com/bugdatabase/view_bug.do bug_id = 7078419

Начиная с R5, OSGi больше не будет поставлять целевые файлы класса jsr14.

[Обновлено 31 октября 2012 года]

OSGi теперь предоставляет перекомпилированные файлы jar 4.3 для Java 7. См.http: //blog.osgi.org/2012/10/43-companion-code-for-java-7.htm

Похожие вопросы